namespace CMSMicroservice.Application.TagCQ.Commands.UpdateTag;
public class UpdateTagCommandValidator : AbstractValidator<UpdateTagCommand>
{
    public UpdateTagCommandValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
        RuleFor(model => model.Name)
            .NotEmpty();
        RuleFor(model => model.Title)
            .NotEmpty();
        RuleFor(model => model.IsActive)
            .NotNull();
        RuleFor(model => model.SortOrder)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<UpdateTagCommand>.CreateWithOptions((UpdateTagCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
